<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "emr_schedule_exception".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EmrScheduleException".
 *
 * Columns in table "emr_schedule_exception" available as properties of the model,
 * followed by relations of table "emr_schedule_exception" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $day_number
 * @property string $date_start
 * @property string $date_end
 * @property integer $enabled_flag
 * @property integer $del_flag
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Provider $provider
 * @property Practice $practice
 * @property EmrScheduleExceptionHour[] $emrScheduleExceptionHours
 */
abstract class BaseEmrScheduleException extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'emr_schedule_exception';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'EmrScheduleException|EmrScheduleExceptions', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('provider_id, practice_id, date_added', 'required'),
            array('provider_id, practice_id, day_number, enabled_flag, del_flag', 'numerical', 'integerOnly'=>true),
            array('date_start, date_end, date_updated', 'safe'),
            array('day_number, date_start, date_end, enabled_flag, del_flag, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, practice_id, day_number, date_start, date_end, enabled_flag, del_flag, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'emrScheduleExceptionHours' => array(self::HAS_MANY, 'EmrScheduleExceptionHour', 'emr_schedule_exception_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'practice_id' => null,
            'day_number' => Yii::t('app', 'Day Number'),
            'date_start' => Yii::t('app', 'Date Start'),
            'date_end' => Yii::t('app', 'Date End'),
            'enabled_flag' => Yii::t('app', 'Enabled Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'provider' => null,
            'practice' => null,
            'emrScheduleExceptionHours' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('day_number', $this->day_number);
        $criteria->compare('date_start', $this->date_start, true);
        $criteria->compare('date_end', $this->date_end, true);
        $criteria->compare('enabled_flag', $this->enabled_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
